package com.android.example;

import com.android.example.MainActivity;

import android.app.Service;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Binder;
import android.os.Bundle;
import android.os.IBinder;

public class GPSService extends Service implements LocationListener {

	private LocationManager locationManager;
	
	private final IBinder mBinder = new MyBinder();
	 
	public GPSService() {
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {

		try {
			locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 5000, 0, this);
		} catch (Exception e) {
		}

		return Service.START_STICKY;
	}

	@Override
	public IBinder onBind(Intent arg0) {
		return mBinder;
	}

	public class MyBinder extends Binder {
		GPSService getService() {
			return GPSService.this;
		}
	}

	@Override
	public void onLocationChanged(Location location) {

		if (location == null) {
		} else {
			MainActivity.setPosition(location.getLatitude(), location.getLongitude());
		}

	}

	@Override
	public void onProviderDisabled(String provider) {
	}

	@Override
	public void onProviderEnabled(String provider) {
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
	}


}
