package com.android.example;

import java.util.Timer;
import java.util.TimerTask;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.webkit.JavascriptInterface;
import android.webkit.WebSettings.RenderPriority;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Toast;

public class MainActivity extends BaseActivity {

	public static String userName = "";

	private static double latitude;
	private static double longitude;

	private Timer timer = new Timer();
	private int timerTick;

	private WebView webView;

	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
		userName = sharedPref.getString(SettingsActivity.user_name_text, "John Doe");		
		
		Intent startServiceIntent1 = new Intent(this, GPSService.class);
        startService(startServiceIntent1);
	
		webView= (WebView) findViewById(R.id.webView);
        webView.clearCache(true);
        webView.getSettings().setRenderPriority(RenderPriority.HIGH);
        webView.getSettings().setJavaScriptEnabled(true);
        
        // This allows our EGL app (JavaScript based) to directly interact with our Android app. 
        webView.addJavascriptInterface(this, "Android");
        
        // The EGL app writes browser log entries. This is where the Android app picks them up.
        webView.setWebChromeClient(new WebChromeClient() {
        	public boolean onConsoleMessage(android.webkit.ConsoleMessage cm) {
		        		
        		Toast.makeText(getApplicationContext(), "EGL wrote this browser log entry: " + cm.message(), Toast.LENGTH_LONG).show();        		
        		
        		return true;
		        		
        	};
		}); 
        webView.setWebViewClient(new WebViewClient());

        startWebApplication();

        startTimer();
	}

	@Override
	protected void onResume() {
		super.onResume();
	}
	
    public static void setPosition(double lat, double lon) {
    	latitude = lat;
    	longitude = lon;
    }
    

    /*
     *  Start the EGL-based web application by loading it into a WebView component.
     */
    private void startWebApplication() {

    	// Load the EGL app into a web view. Pass the user name from Android Settings into the EGL app.
        try {
            webView.loadUrl("http://www.xxxxxxxxxxxxxxxxxxxxxxxxxx.com/AndroidExample/MessageUI-en_US.html?userName=" + userName);
		} catch (Exception e) {	}

    }
    
    /*
     *  Start a timer and send information from the Android app to the EGL app when the timer fires.
     */
    private void startTimer() {
		timer.scheduleAtFixedRate(new TimerTask() {
			@Override
			public void run() {
				try {
					timerTick++;
					webView.loadUrl("javascript:egl.rootHandler.timerCountInterface('" + timerTick + "');");
				} catch (Exception e) {	}
			}
		}, 5000, 10000);
    }
    
    /*
     *  EGL directly calls this method. The Android app displays a Toast using the message passed from EGL.
     *  The @JavacriptInterface annotation exposes this method so that our EGL app can call it.
     *  See also the "addJavascriptInterface" method call elsewhere in this program.
     */
	@JavascriptInterface
    public void sendMessageToAndroid(String message) {

		Toast.makeText(getApplicationContext(), "EGL sent Android this message: " + message, Toast.LENGTH_LONG).show();
	}

    /* EGL directly calls this method. The Android app returns GPS position information.
     *  The @JavacriptInterface annotation exposes this method so that our EGL app can call it.
     *  See also the "addJavascriptInterface" method call elsewhere in this program.
     */
	@JavascriptInterface
    public String getLocationDataFromAndroid() {

    	return latitude + ", " + longitude;
		
	}

}